// JEU CAPTURE DE DRAPEAUX

void flag(){
  while(1){  

//lecture de l'état des boutons

    etat_boutonR = digitalRead(BP_PinR);
    etat_boutonB = digitalRead(BP_PinB);

    if (etat_boutonR == HIGH ){red();}
    if (etat_boutonB == HIGH ){blue();}


// Affichage de l'état de la base

    lcd.setCursor (0,0);
    if (bleu == 0 && rouge == 0) {lcd.print ( "  BASE  NEUTRE  ");}
    if (rouge == 1) {lcd.print ( "  RESPAWN ROUGE ");}
    if (bleu == 1) {lcd.print ( "  RESPAWN BLEU  ");}

    if (rouge == 1){compteurR = TinterR + millis() - TinitR;}
    if (bleu == 1){compteurB = TinterB + millis() - TinitB;}

    printCompteurs (compteurR, compteurB);  

  } // End While
} // End Void FLAG  



// Fonction Calcul Compte à Rebour de la Bombe
void printCompteurs (unsigned long compteurR, unsigned long compteurB){

// Affichage Compteur Rouge
  timeCalc = (compteurR/60000);
  lcd.setCursor(0,1); lcd.print("R ");
// Affichage Minutes Rouge
  if((timeCalc%60)<10){lcd.print("0"); lcd.print(timeCalc%60);}
    else {lcd.print(timeCalc%60);}
  lcd.print(":");
// Affichage Secondes Rouge
  timeCalc=(compteurR/1000);
  if((timeCalc%60)<10){lcd.print("0"); lcd.print(timeCalc%60);}
    else {lcd.print(timeCalc%60);}
  lcd.print(" ");

// Affichage Compteur Bleu
  timeCalc=(compteurB/60000);
  lcd.write((uint8_t) 1);
// Affichage Minutes Bleu
  if((timeCalc%60)<10){lcd.print("0"); lcd.print(timeCalc%60);}
    else {lcd.print(timeCalc%60);}
  lcd.print(":");
// Affichage Secondes Bleu
  timeCalc=(compteurB/1000);
  if((timeCalc%60)<10){lcd.print("0"); lcd.print(timeCalc%60);}
    else {lcd.print(timeCalc%60);}
  lcd.print(" B");
  
} // End Void printCompteurs



// Appui bouton ROUGE
void red(){

    if (etat_boutonR == HIGH ){
          debut_appuiR = millis();
          
          while(etat_boutonR == HIGH & rouge == 0 ) {
 
                // Base Neutre --> Base Rouge
                if (bleu == 0){
                    lcd.setCursor(0, 1 ); lcd.print( "                " );      
                    for (int i = 0; i<=15; i++){
                         for (int j = 1; j<=5; j++){
                             lcd.setCursor(i,1);
                             lcd.write((uint8_t) j);
                         delay (Tflag/5);
                         etat_boutonR = digitalRead(BP_PinR);
                         if (etat_boutonR == LOW){break;}
                         
                         // Basculement Base Rouge
                             if (i == 15 && j == 5){
                                 rouge = 1;
                                 if (buzzer)tone (buzz_Pin, 4000, 500);
                                 TinitR = millis();         
                                 etat_ledB = LOW;                      
                                 etat_ledR = HIGH;
                                 digitalWrite(led_PinR, etat_ledR);
                                 digitalWrite(led_PinB, etat_ledB);
                                 lcd.setCursor(0,0); lcd.print("  RESPAWN ROUGE  ");
                                 lcd.setCursor(0,0);
                             } // End if

                         } // End for j
                    if (etat_boutonR == LOW){break;}
                    } // End for i  
                }  //end if                
                
                // Base Bleu --> Base Neutre
                if (bleu == 1){
                    Barre();
                    for (int i = 15; i>=0; i--){
                         for (int j = 5; j>=0; j--){
                             lcd.setCursor(i,1);
                             lcd.write((uint8_t) j);
                             delay (Tflag/5);
                             etat_boutonR = digitalRead(BP_PinR);
                             if (etat_boutonR == LOW){Barre(); break;}
                             
                          // Basculement Base Neutre                             
                             if (i == 0 && j == 0){
                                 bleu = 0;
                                 if (buzzer)tone (buzz_Pin, 4000, 500);
                                 TinterB = compteurB;
                                 etat_ledR = LOW;                      
                                 etat_ledB = LOW;
                                 digitalWrite(led_PinR, etat_ledR);
                                 digitalWrite(led_PinB, etat_ledB);
                                 lcd.setCursor(0,0); lcd.print("  BASE  NEUTRE  ");
                             } // End If

                         } // End for j
                         if (etat_boutonR == LOW){Barre(); break;}
                    } // End for i  
                }  //end if                

                etat_boutonR = digitalRead(BP_PinR);

                delay (Tflag);
                
          }  //end while
          
    }  //end if
}  // End void rouge



// Appui bouton BLEU
void blue(){

    if (etat_boutonB == HIGH ){
          debut_appuiB = millis();
          
          while(etat_boutonB == HIGH & bleu == 0 ) {
 
                // Base Neutre --> Base Bleue
                if (rouge == 0){
                     lcd.setCursor(0,1); lcd.print( "                " );      
                     for (int i = 0; i<=15; i++){
                         for (int j = 1; j<=5; j++){
                             lcd.setCursor(i,1);
                             lcd.write((uint8_t) j);
                             delay (Tflag/5);
                             etat_boutonB = digitalRead(BP_PinB);
                             if (etat_boutonB == LOW){break;}
                         
                         // Basculement Base Bleue
                             if (i == 15 && j == 5){
                                 if (buzzer)tone (buzz_Pin, 4000, 500);
                                 bleu = 1;
                                 TinitB = millis();
                                 etat_ledR = LOW;                      
                                 etat_ledB = HIGH;
                                 digitalWrite(led_PinR, etat_ledR);
                                 digitalWrite(led_PinB, etat_ledB);
                                 lcd.setCursor(0,0);
                                 lcd.print("  RESPAWN BLEU  ");
                                 lcd.setCursor(0,0);
                             } // End if
                             
                         } // End for j
                     if (etat_boutonB == LOW){break;}
                     } // End for i  
                }  //end if                
                
                // Base Rouge --> Base Neutre
                if (rouge == 1){
                    Barre();
                    for (int i = 15; i>=0; i--){
                         for (int j = 5; j>=0; j--){
                             lcd.setCursor(i,1);
                             lcd.write((uint8_t) j);
                             delay (Tflag/5);
                             etat_boutonB = digitalRead(BP_PinB);
                             if (etat_boutonB == LOW){Barre(); break;}

                         // Basculement Base Neutre                             
                             if (i == 0 && j == 0){
                                 rouge = 0;
                                 if (buzzer)tone (buzz_Pin, 4000, 500);
                                 TinterR = compteurR;
                                 etat_ledR = LOW;                      
                                 etat_ledB = LOW;
                                 digitalWrite(led_PinR, etat_ledR);
                                 digitalWrite(led_PinB, etat_ledB);
                                 lcd.setCursor(0,0);
                                 lcd.print("  BASE  NEUTRE  ");
                             } // End If
                             
                         } // End for j
                         if (etat_boutonB == LOW){Barre(); break;}
                    } // End for i  
                }  //end if
                
                etat_boutonB = digitalRead(BP_PinB);

                delay (Tflag);
                
          }  //end while
          
    }  //end if
}  // End Void bleu





