// JEU BOMBE

void bombe(){
  
  lcd.clear();
  lcd.setCursor(5,0); lcd.print("BOMBE");

  minutes = minutes - 1;
 
  while(1){

    if (digitalRead(BP_PinB) == HIGH ){Amorcage();}
    if (digitalRead(BP_PinR) == HIGH ){Amorcage();}
    
// La Bombe est Rouge    
    if (rouge == 1){
    TimeInit=millis(); //  initialTime in millisec
        while(rouge == 1){
            secondes=millis()- TimeInit;
         // Affichage Temps
            printTime(minutes, secondes);
        // Vérification désamorçage
            if (digitalRead(BP_PinB) == HIGH){Desamorcage();}
        // Vérification fin compte à rebour
            if(minutes-secondes/60000==0 && 59-((secondes/1000)%60)==0){Boum();}
          } //End While
    } // End if Rouge
    
// La Bombe est Bleu
    if (bleu == 1){
    TimeInit=millis(); //  initialTime in millisec
        while(bleu == 1){
            secondes=millis()- TimeInit;
         // Affichage Temps
            printTime(minutes, secondes);
             
        // Vérification désamorçage
            if (digitalRead(BP_PinR) == HIGH){Desamorcage();}
        // Vérification fin compte à rebour
            if(minutes-secondes/60000==0 && 59-((secondes/1000)%60)==0){Boum();}
        } //End While
    } // End if Bleu

    if (bleu == 0 & rouge == 0){lcd.setCursor(0,1);lcd.print ("                ");}
  } // End While
} // End Void BOMBE  



// Fonction Calcul Compte à Rebour de la Bombe
void printTime(unsigned long minutes, unsigned long secondes){

    timeCalcVar=(minutes-secondes/60000);
    lcd.setCursor(0,1); lcd.print("     ");
// Affichage Minutes
    if((timeCalcVar%60)<10){lcd.print("0"); lcd.print(timeCalcVar%60);}
    else {lcd.print(timeCalcVar%60);}
    lcd.print(":");
// Affichage Secondes
    timeCalcVar=(secondes/1000);
    if((59-(timeCalcVar%60))<10){lcd.print("0"); lcd.print(59-(timeCalcVar%60));}
    else {lcd.print(59-(timeCalcVar%60));}
    lcd.print("      ");

// Gestion du son
    timeCalcVar=(millis()- TimeInit)%1000;
    if (timeCalcVar >= 989 && timeCalcVar <= 999 && minutes-secondes/60000<2 && buzzer)tone(buzz_Pin, 4000, bip);
    if (timeCalcVar >= 989 && timeCalcVar <= 999 && minutes==1 && secondes/1000==59 && buzzer)tone(buzz_Pin, 4000, 500);
    if (timeCalcVar >= 489 && timeCalcVar <= 499 && minutes-secondes/60000<1 && buzzer)tone(buzz_Pin, 4000, bip);
    if (timeCalcVar >= 745 && timeCalcVar <= 760 && minutes-secondes/60000==0 && 59-((secondes/1000)%60) < 10 && buzzer)tone(buzz_Pin, 4000, bip);
    if (timeCalcVar >= 245 && timeCalcVar <= 260 && minutes-secondes/60000==0 && 59-((secondes/1000)%60) < 10 && buzzer)tone(buzz_Pin, 4000, bip);
    if( minutes-secondes/60000==0 && 59-((secondes/1000)%60) < 60) bip = 300;
    if( minutes-secondes/60000==0 && 59-((secondes/1000)%60) < 10) bip = 200;
    
} // End Void printTime



// Amorçage Bombe
void Amorcage(){

// --> BOMBE ROUGE
    if (digitalRead(BP_PinR) == HIGH ){
        while(digitalRead(BP_PinR) == HIGH & rouge == 0 ) {
            lcd.print( "                " );      
            for (int i = 0; i<=15; i++){
                for (int j = 1; j<=5; j++){
                    lcd.setCursor(i,1);
                    lcd.write((uint8_t) j);
                    delay (Tamorc/5);
                    if (digitalRead(BP_PinR) == LOW){break;}
            // Amorçage complet
                    if (i == 15 && j == 5){
                        rouge = 1;
                        if (buzzer)tone (buzz_Pin, 4000, 500);
                        digitalWrite(led_PinR, HIGH);
                        digitalWrite(led_PinB, LOW);
                    } // End if
                } // End for j
                if (digitalRead(BP_PinR) == LOW){break;}
            } // End for i
            if (digitalRead(BP_PinR) == LOW){break;}
            delay (Tamorc);
        }  //end while
    }  //end if

// --> BOMBE BLEU
    if (digitalRead(BP_PinB) == HIGH ){
        while(digitalRead(BP_PinB) == HIGH & bleu == 0 ) {
            lcd.print( "                " );      
            for (int i = 0; i<=15; i++){
                for (int j = 1; j<=5; j++){
                    lcd.setCursor(i,1);
                    lcd.write((uint8_t) j);
                    delay (Tamorc/5);
                    if (digitalRead(BP_PinB) == LOW){break;}
            // Amorçage complet
                    if (i == 15 && j == 5){
                        bleu = 1;
                        if (buzzer)tone (buzz_Pin, 4000, 500);
                        digitalWrite(led_PinR, LOW);
                        digitalWrite(led_PinB, HIGH);
                    } // End if
                } // End for j
                if (digitalRead(BP_PinB) == LOW){break;}
            } // End for i
            if (digitalRead(BP_PinB) == LOW){break;}
            delay (Tamorc);
        }  //end while
    }  //end if
    
}  // End Void Amorçage



// Fonction désamorçage de la Bombe
void Desamorcage(){

// Si la Bombe est Rouge
    if (rouge == 1){
        Barre();
        while (rouge == 1 ){
            for (int i = 15; i>=0; i--){
                for (int j = 5; j>=0; j--){
                    lcd.setCursor(i,1);
                    lcd.write((uint8_t) j);
                    delay (Tdesamorc/5);
                    if (digitalRead(BP_PinB) == LOW){Barre(); break;}
             // Désamorcage Complet                             
                    if (i == 0 && j == 0){PasBoum();}
                } // End for j
                if (digitalRead(BP_PinB) == LOW){Barre(); break;}
            } // End for i
            if (digitalRead(BP_PinB) == LOW){Barre(); break;}
        } // End while
    }  // End if                

// Si la Bombe est Bleu
    if (bleu == 1){
        Barre();
        while (bleu == 1 ){
            for (int i = 15; i>=0; i--){
                for (int j = 5; j>=0; j--){
                    lcd.setCursor(i,1);
                    lcd.write((uint8_t) j);
                    delay (Tdesamorc/5);
                    if (digitalRead(BP_PinR) == LOW){Barre(); break;}
             // Désamorcage Complet                             
                    if (i == 0 && j == 0){PasBoum();}
                } // End for j
                if (digitalRead(BP_PinR) == LOW){Barre(); break;}
            } // End for i
            if (digitalRead(BP_PinR) == LOW){Barre(); break;}
        } // End while
    }  // End if                

} // End void desamorcage



// Fin Scénario Bombe : Bombe explose
void Boum(){
    lcd.clear();
    while (1){
        lcd.setCursor(6,0); lcd.print("BOUM"); 
        if (rouge == 1){lcd.setCursor(2,1);lcd.print("ROUGE GAGNE");}
        if (bleu == 1){lcd.setCursor(2,1);lcd.print("BLEU GAGNE");}
        for (int i = 1; i<10; i++){
            for(int j = 1800; j<2200; j++){if(buzzer){tone(buzz_Pin,j);delay(1);}}
            noTone(buzz_Pin);
            for(int j = 2200; j>1800; j--){if(buzzer){tone(buzz_Pin,j);delay(1);}}
        } // End For i
        noTone(buzz_Pin);
        break;
    } // End while
    while(1);
} // End void  Boum



// Fin Scénario Bombe : Bombe désamorcée
void PasBoum(){
    lcd.clear();
    while (1){
        lcd.setCursor(0,0); lcd.print("BOMBE DESAMORCEE"); 
        if (rouge == 1){lcd.setCursor(2,1);lcd.print("BLEU GAGNE");}
        if (bleu == 1){lcd.setCursor(2,1);lcd.print("ROUGE GAGNE");}
        if (buzzer)tone (buzz_Pin, 500, 5000);
        break;
    } // End while
    while(1);
} // End void PasBoum

